--This script will run on all levels when mod is active.
--Modding documentation: http://teardowngame.com/modding
--API reference: http://teardowngame.com/modding/api.html


--Visiual offset for tool in hand
HAND_OFFSET = Transform(Vec(0.3, -0.4, -0.5),QuatEuler(-90,0,0))

--Offset which is applied to thrown grenade from hand position
THROW_OFFSET = Transform(Vec(0.1, -0.3, -0.3), QuatEuler(90, 0, 0))
--Throw force applied to the grenade
THROW_FORCE = 20
--Throw angular force applied to the grenade
THROW_ANGULAR_FORCE = 20

function init()
    RegisterTool('orbitalstrike','Orbital Strike','MOD/grenade.vox')
    SetBool('game.tool.orbitalstrike.enabled',true)
end

function tick(dt)
    if GetString('game.player.tool') == "orbitalstrike" then
        --Get the grenade shape in the tool
        local tool = GetToolBody()
        local grenade = GetBodyShapes(tool)[1]

        --Offset the grenade so it does not clip with the camera
        SetShapeLocalTransform(grenade,HAND_OFFSET)

        if InputPressed('usetool') then
            --Get the tool position
            local parent = GetShapeWorldTransform(grenade)
            local t = TransformToParentTransform(parent, THROW_OFFSET)

            --Spawn the grenade and get the parent body
            local obj = Spawn("MOD/grenade.xml", t)
            local body = obj[1]
            
            --Find the throw direction and magnitude
            local cam = GetCameraTransform()
            local vel = TransformToParentVec(cam,{0, 0, -1})
            vel = VecScale(vel, THROW_FORCE)

            --Apply the velocity to the grenade
            SetBodyVelocity(body, vel)
            
            --Get the grenade angular velocity
            local angVel = TransformToParentVec(cam,{-1, 0, 0})
            angVel = VecScale(angVel, THROW_ANGULAR_FORCE)

            --Apply angular velocity
            SetBodyAngularVelocity(body,angVel)
        end
    end
end


function update(dt)
end


function draw(dt)
end


