SPACING = 40
DESC_SPACING = 40
NEEDLE_SHAKE = 0.1

performanceImpact = 0
needlePos = 0



function draw()
    performanceImpact = 0

    local sWidth = UiWidth()
    local sHeight = UiHeight()

    UiTranslate(80, 80)
    UiWindow(sWidth - 160, sHeight - 160)

    local width = UiWidth()
    local height = UiHeight()

    UiPush()
        UiWindow(width/2, height)
            UiPush()
                local w = UiWidth()
                local h = UiHeight()
                UiColor(0.1,0.1,0.1)
                UiImageBox("ui/common/box-solid-6.png", w, h, 6, 6)
            UiPop()
            UiPush()
                UiTranslate(10, 10)
                UiWindow(w - 10, h - 10, true)
                    SliderProperty("Explosion Size", "The size of the explosion.", "shellCount", 3, 30, 15, 1, 4)
                    SliderProperty("Explosion Shell Delay", "The speed of the explosion. Lower makes the explosion travel faster.", "shellDelay", 0.1, 3, 0.1, 0.1, -3)
                    SliderProperty("Explosion Shell Gap", "The gap between the sub-explosions. Turining this value too high may create holes in the explosion.", "shellGap", 1, 4, 3.5, 0.1, 0.1)
                    SliderProperty("Explosion Force", "The force applied to objects in the explosion (kilonewtons).", "explosionForce", 100, 1000, 500, 100, 0.02)
            UiPop()
    UiPop()

    UiPush()
        UiTranslate(width/2, 0)
        UiWindow(width/2, height)
            local w = UiWidth()
            local h = UiHeight()
            UiTranslate(w/2, h/2)
            UiAlign("center middle")
            UiImageBox('MOD/dial.png',w - 300,w - 300,0,0)
            UiPush()
                UiTranslate(0,30)
                UiAlign("top center")
                UiColor(0.1, 0.1, 0.1)
                UiFont("bold.ttf", 20)
                UiText("GPU combustion probability.")
            UiPop()

            UiRotate(-MapRange(needlePos, 20, 140, 0, 180))
            UiImageBox('MOD/needle.png',w - 300,w - 300,0,0)
    UiPop()
    needlePos = lerp(needlePos, performanceImpact + (math.random(-NEEDLE_SHAKE * performanceImpact, NEEDLE_SHAKE * performanceImpact)), 0.1)
end

function Property(name, desc, key, draw)
    local width = UiWidth() - 100
    UiAlign('top left')
    UiFont("bold.ttf", 30)
    UiText(name)
    UiPush()
        local w, h = UiGetTextSize(name)
        UiTranslate(w + 10, h/2)
        UiAlign('middle left')
        local result = draw(width - w)
    UiPop()
    UiPush()
        UiTranslate(width + 50, h/2)
        UiAlign("center middle")
        UiText(result)
    UiPop()
    UiTranslate(0, DESC_SPACING)
    UiFont("regular.ttf", 20)
    UiText(desc)
    UiTranslate(0, SPACING)
end

function SliderProperty(name, desc, key, min, max, defualt, snap, performance)
    Property(name, desc, key, function(w)
        local path = Path(key)
        local current = GetFloat(path)
        if not HasKey(path) then current = defualt end
        local new = UiSlider("ui/common/dot.png",'x',MapRange(current, min, max, 0, w),0,w)
        UiTranslate(10, 0)
        UiRect(w,5)
        new = MapRange(new, 0, w, min, max)
        new = Round(new, snap)
        SetFloat(Path(key),new)

        performanceImpact = performanceImpact + (new * performance)

        return new
    end)
end

function Path(key)
    return "savegame.mod." .. key
end

function MapRange(t, f1, f2, t1, t2)
    t = t - f1
    t = t / (f2-f1)

    t = t * (t2-t1)
    t = t + t1

    return t
end

function Round(val, snap)
    snap = snap or 1
    
    return math.floor((val / snap) + 0.5)*snap
end

function lerp(a, b, t)
    return a + (t * (b-a))
end